#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef vector<vector<ll>> graph;

//lca
// req: dp[N][log N] - memorization,
//      par[N]       - parent of i
//      lev[N]       - depth of i
// usage: fill the array, run process, then query
ll N, LOG=30;
vector<vector<ll>> dp;
vector<ll> par;
void process() {
    dp.assign(N, vector<ll>(LOG, -1));
    for(int i=0; i<N; ++i) dp[i][0] = par[i];
    for(int j=1; j<LOG; ++j){
        for(int i=0; i<N; ++i) if(dp[i][j-1] != -1){
            dp[i][j] = dp[dp[i][j-1]][j-1];
        }
    }
}
vector<ll> lev;
ll lca(ll p, ll q)  {
    if (lev[p] < lev[q]) swap(p, q);
    ll log=LOG-1;
    for(ll i=log;i>=0;i--){
        if (lev[p] - (1 << i) >= lev[q]){
            p = dp[p][i];
        }
    }
    if (p==q)return p;
    for(ll i=log;i>=0;i--){
        if (~dp[p][i] && dp[p][i] != dp[q][i]){
            p = dp[p][i];
            q = dp[q][i];
        }
    }
    return par[p];
}
///lca

int main(){
    ll M; cin >> N >> M;
    graph g(N);
    lev = vector<ll>(N, -1);
    par = vector<ll>(N, 0);
    for(ll i=0; i<M; ++i){
        ll a, b; cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    set<pair<ll,ll>> next, nnext;
    next.insert({0,0});
    vector<ll> order(1,0);
    while(true){
        for(auto p : next)if(lev[p.first]==-1){
            ll a = p.first;
            if(a!=p.second){
                par[a] = p.second;
                order.push_back(a);
            }
            lev[a] = lev[p.second]+1;
            for(ll n:g[a])if(lev[n]==-1){
                nnext.insert({n, a});
            }
        }
        if(nnext.empty()) break;
        next = nnext;
        nnext.clear();
    }
    process();
    // cerr<<"par: ";for(ll p:par)cerr << p << ' ';cerr<<endl;
    ll total = 0;
    for(ll i=0; i<N-1; ++i){
        ll a = order[i];
        ll b = order[i+1];
        ll LCA = lca(a,b);
        total += lev[a]+lev[b]-2*lev[LCA];
        // cerr<<a<<": "<<lev[a]<<' ' <<lev[b] << ' ' <<LCA<<' ' <<lev[LCA]<<endl;
    }
    cout << total << endl;
    return 0;
}
